package p06_enkapsulacja;

public class Konto {
    private final int numer;
    private Osoba wlasciciel;
    private int saldo;

    public Konto(int numer, Osoba wlasciciel, int saldo) {
        this.numer = numer;
        this.wlasciciel = wlasciciel;
        this.saldo = saldo;
    }

    @Override
    public String toString() {
        return "Konto nr " + numer + ", wł: " + wlasciciel + ", saldo: " + saldo;
    }

    // Nie tworzymy setterów do pól:
    // - numer - ponieważ numer nigdy się nie zmienia
    // - saldo - ponieważ zmiany salda muszą być wykonane za pomocą "operacji biznesowych" wplata / wyplata / przelew
    public int getNumer() {
        return numer;
    }

    public Osoba getWlasciciel() {
        return wlasciciel;
    }

    public void setWlasciciel(Osoba wlasciciel) {
        this.wlasciciel = wlasciciel;
    }

    public int getSaldo() {
        return saldo;
    }

    public void wplata(int kwota) {
        saldo += kwota;
    }

    public void wyplata(int kwota) {
        saldo -= kwota;
    }

    public void przelew(Konto cel, int kwota) {
        this.saldo -= kwota;
        cel.saldo += kwota;
    }
}
